/* 
 * Copyright 1991 Oliver Jones
 * Permission to use, copy, modify, distribute, and sell this software
 * for any purpose is hereby granted without fee.  No representations
 * are made by anyone about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty. 
 */

#include <X11/Xlib.h>
#define GC_ALL_FLAGS  ((1L<<(GCLastBit+1L))-1L)

void 
Arrow (dpy, win, gc, gctmp, size, xh, yh, xt, yt)
     Display * dpy;
     Drawable  win;
     GC        gc;
     GC        gctmp;
     int       size;
     int       xh, yh;
     int       xt, yt;

{
  XPoint pt[6];
  int dx, dy;
  extern double sqrt();

  int lenx = xh - xt;
  int leny = yh - yt;
  int hsize = size * 5;
  double flenx = (lenx<<8);
  double fleny = (leny<<8);
  double flen = 0.5e0 + sqrt ( (flenx*flenx) + (fleny*fleny));
  int len = flen;

  len >>= 8;  

  XCopyGC (dpy, gc, GC_ALL_FLAGS, gctmp);
  XSetLineAttributes (dpy, gctmp, size, 
		      LineOnOffDash, CapButt, JoinMiter);

  if (len > 0) {
    /* tip */
    pt[0].x = pt[3].x = xh;
    pt[0].y = pt[3].y = yh;
    /* first corner:  half a size unit up from the line, sqrt(3) back */
    dx = 0;
    dx -= ((lenx * hsize * 173) / (len * 200));   /* back */
    dx -= ((leny * hsize * 100) / (len * 200));   /* up */
    dy = 0;
    dy -= ((leny * hsize * 173) / (len * 200));   /* back */
    dy += ((lenx * hsize * 100) / (len * 200));   /* up */
    pt[1].x = xh + dx;
    pt[1].y = yh + dy;
    
    /* second corner:  half a size unit down from the line, sqrt(3) back */
    dx = 0;
    dx -= ((lenx * hsize * 173) / (len * 200));   /* back */
    dx += ((leny * hsize * 100) / (len * 200));   /* down */
    dy = 0;
    dy -= ((leny * hsize * 173) / (len * 200));   /* back */
    dy -= ((lenx * hsize * 100) / (len * 200));   /* up */
    pt[2].x = xh + dx;
    pt[2].y = yh + dy;
    
    /* trim head   */
    if ( len >  (hsize/2)) {
      xh -= ((lenx *  (hsize*173/200)) / len);
      yh -= ((leny *  (hsize*173/200)) / len);
    } 
    if ( len > (hsize*173/200)){
      XDrawLine ( dpy, win, gctmp, xt,yt,xh,yh );
    }
    XFillPolygon (dpy, win, gctmp, pt, 4, Convex, CoordModeOrigin);
  }
}

