#ifndef _WDIAG_H_
#define _WDIAG_H_
/*
 * wdiag -- widget hierarchy diagnostics
 */

#ifndef _XtIntrinsic_h
#include <X11/Intrinsic.h>
#endif

#define XtSpecificationRelease 4

#ifdef XTFUNCPROTO
#undef NeedFunctionPrototypes
#define NeedFunctionPrototypes 1
#else
#undef NeedFunctionPrototypes
#define NeedFunctionPrototypes 0
#undef NeedWidePrototypes
#define NeedWidePrototypes 0
#endif

#ifndef NeedFunctionPrototypes
#if defined(FUNCPROTO) || defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#define NeedFunctionPrototypes 1
#else
#define NeedFunctionPrototypes 0
#endif /* __STDC__ */
#endif /* NeedFunctionPrototypes */

/* NeedVarargsPrototypes is temporary until function prototypes work everywhere */
#ifndef NeedVarargsPrototypes
#if defined(FUNCPROTO) || defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus) || NeedFunctionPrototypes
#define NeedVarargsPrototypes 1
#else
#define NeedVarargsPrototypes 0
#endif /* __STDC__ */
#endif /* NeedVarargsPrototypes */

#if defined(__cplusplus) || defined(c_plusplus)
#define CONST const
/* make const String do the right thing */
#define String char*
#else
#define CONST
#endif /* __cplusplus */

#ifndef NeedWidePrototypes
#if defined(NARROWPROTO)
#define NeedWidePrototypes 0
#else
#define NeedWidePrototypes 1		/* default to make interropt. easier */
#endif
#endif

#ifndef NULL
#define NULL 0
#endif

#ifdef VMS
#define externalref globalref
#define externaldef(psect) globaldef {"psect"} noshare
#else
#define externalref extern
#define externaldef(psect)
#endif /* VMS */

#ifndef FALSE
#define FALSE 0
#define TRUE 1
#endif

/***************************************************************
 *
 * Exported Interfaces
 *
 ****************************************************************/

#ifdef __cplusplus			/* do not leave open across includes */
extern "C" {				/* for C++ V2.0 */
#endif

extern char * nameof (
#if NeedFunctionPrototypes
    Widget 		/* widget */
#endif
);

extern char * classof (
#if NeedFunctionPrototypes
    Widget 		/* widget */
#endif
);

extern Widget rootof (
#if NeedFunctionPrototypes
    Widget 		/* widget */
#endif
);

extern void treeof (
#if NeedFunctionPrototypes
    Widget 		/* widget */
#endif
);

extern char * valueof (
#if NeedFunctionPrototypes
    Widget 		/* widget */,
    char *              /* resource name */
#endif
);


#ifdef __cplusplus
}						/* for C++ V2.0 */
#endif

#if NeedWidePrototypes
#undef Boolean
#undef Dimension
#undef KeyCode
#undef Position
#undef XtEnum
#endif /* NeedWidePrototypes */

#undef String
#undef CONST

#endif
